;;;***********************************
;;;***********************************
;;;
;;;	UBS
;;; Berechnungsprogramm fr Symetrische und Asymetrische bergangsstcke
;;;
;;;	Programmiert von
;;;
;;;	CAD-Technik Nelkel
;;;	Wilfried Nelkel
;;;	In der Langen Nacht 18
;;;	92289 Hohenkemnath
;;;	Tel. 09628/914144
;;;	Fax. 09628/914145
;;;	eMail: autocad@cad-nelkel.de
;;;	Web:   http://www.cad-nelkel.de
;;;
;;;***********************************
;;;***********************************
;;;
;;;
;;; Lauffhig unter AutoCAD 2002

(DEFUN C:UBS (/
;;;	      DCL_ID	    ETSTAT     UMFANG	  SEGLN     SEGWIN	EINF1	   C	      RPKT1
;;;	      RPKT2	 RPKT3	    RPKT4      EINF2	  P2_1	     P2_2	P2_3	   P2_4	      P2_5
;;;	      ALTOS	 INDEX	    SS1	       SS2	  SS3	     SS4	LANG_LI	   START_LI   OBJEKT1
;;;	      OBJEKT_DATA1	    START_PKT1 END_PKT1	  LNGE1     PUNKT_LI	PUNKT	   PUNKT2     PUNKT3
;;;	      PUNKT4	 PUNKT5	    RADLANG    P3_1	  LZ	     LZ1	P3_3	   P3_2	      LANG1
;;;	      LANG3	 ALPHA	    PLINE_LI   WINKUNTEN1O	     WINKUNTEN1U	   WINKUNTEN1 WINKUNTEN
;;;	      WINKELLINKS	    ELE	       OBJL	  EP	     OBJ	STP	   ENP	      COSVONX
;;;	      LAYNAM	 EINTRAG    LAY_LIS    T-INFORMATION	     FARBE	RM1	   RM2	      RM3
;;;	      RM4	 KPK1	    KPK2       KPK3	  KPK4	     LM1	LM2	   LM3	      LM4
;;;	      EINFZ1	 EINF1	    EINF2      ALTOS	  UMFANG_OBJ_LI		ELE	   FLCHE     UMFANG
;;;	      INDEX	 LZ1	    LANG1      ALPHA	  P3_2	     P3_3	P3_1	   ENP	      STP
;;;	      LANG2	 P_TEMP	    TEXT_INDEX TEXT_EINTRAG_LI	     TEXT_WIN_LI	   TEXT_START_LI
;;;	      LANG_LI1	 LANG_LI2   LANG_LI3   LANG_LI4	  START_LI1  START_LI2	START_LI3  START_LI4  PUNKT_LI1
;;;	      PUNKT_LI2	 PUNKT_LI3  PUNKT_LI4  PYT_A	  HD1	     HD2	HD3	   HD4	      PYT_B
;;;	      P_TEMP	 VOR_FARBE  OBJL       EP	  PLINE_LI   OBJ	STARTPUNKT
	     )

  (SETQ	DCL_ID	 (LOAD_DIALOG "UBS.DCL")
	FARBE	 (GETVAR "cecolor")
	A_CMD	 (GETVAR "cmdecho")
	A_LAY	 (GETVAR "clayer")
	A_FAR	 (GETVAR "cecolor")
	TEXTHHE 3.5
  )
  (IF (NULL ST)
    (SETQ ST 0)
  )
  (IF (NULL X)
    (SETQ X 0)
  )
  (IF (NULL Y)
    (SETQ Y 0)
  )

  (IF A_TEMP
    (SETQ A A_TEMP)
  )
  (IF B_TEMP
    (SETQ B B_TEMP)
  )
  (IF D_TEMP
    (SETQ D D_TEMP)
  )
  (IF (NULL SYMETRISCH)
    (SETQ SYMETRISCH 1)
  )

  (SETVAR "cmdecho" 0)
  (IF (NULL (NEW_DIALOG "UBS" DCL_ID))
    (ALERT
      "\nKann die Dialogboxdatei UBS.DCL \n nicht finden / laden !"
    )
  )
  (IF (= SYMETRISCH 1)
    (PROGN
      (DIA_ZEIG)
      (SET_TILE "sy" "1")
    )
    (PROGN
      (DIA_ZEIG_A)
      (SET_TILE "asy" "1")
    )
  )
  (FARBZEIG)
  (UBS_LAY_EINL)
  (IF (NULL G)
    (SETQ G 24)
  )
  (START_LIST "laylist")
  (MAPCAR 'ADD_LIST LAY_LIS)
  (END_LIST)
  (START_LIST "winklist")
  (MAPCAR 'ADD_LIST (SETQ WINKLIST (LIST "12" "16" "20" "24" "28" "32" "36" "40" "44" "60")))
  (END_LIST)
  (IF FARBE
    (SET_TILE "farbe" FARBE)
  )
  (COND
    ((= G 12) (SET_TILE "winklist" "0"))
    ((= G 16) (SET_TILE "winklist" "1"))
    ((= G 20) (SET_TILE "winklist" "2"))
    ((= G 24) (SET_TILE "winklist" "3"))
    ((= G 28) (SET_TILE "winklist" "4"))
    ((= G 32) (SET_TILE "winklist" "5"))
    ((= G 36) (SET_TILE "winklist" "6"))
    ((= G 40) (SET_TILE "winklist" "7"))
    ((= G 44) (SET_TILE "winklist" "8"))
    ((= G 60) (SET_TILE "winklist" "9"))
  )
  (IF A
    (SET_TILE "A" (RTOS A 2 3))
  )
  (IF D
    (SET_TILE "D" (RTOS D 2 3))
  )
  (IF H
    (SET_TILE "H" (RTOS H 2 3))
  )
  (IF B
    (SET_TILE "B" (RTOS B 2 3))
  )
  (IF ST
    (SET_TILE "T" (RTOS ST 2 3))

  )
  (IF X
    (SET_TILE "X" (RTOS X 2 3))
  )
  (IF Y
    (SET_TILE "Y" (RTOS Y 2 3))
  )
  (ACTION_TILE "laylist" "(take-layer)")
  (ACTION_TILE "farbe" "(prfe_farbe)")
  (ACTION_TILE "sy" "(dia_zeig) (SETQ symetrisch 1)")
  (ACTION_TILE "asy" "(dia_zeig_a) (SETQ symetrisch 0)")
  (ACTION_TILE "A" "(setq A (atof $value))")
  (ACTION_TILE "t-info" "(alert-t-info)")
  (ACTION_TILE "color" "(DONE_DIALOG 2)")
  (ACTION_TILE "B" "(setq B (atof $value))")
  (ACTION_TILE "D" "(setq D (atof $value))")
  (ACTION_TILE "H" "(setq H (atof $value))")
  (ACTION_TILE "T" "(setq ST (atof $value))")
  (ACTION_TILE "X" "(setq X (atof $value))")
  (ACTION_TILE "Y" "(setq Y (atof $value))")
  (ACTION_TILE "winklist" "(SETQ G (ATOI (NTH (ATOI $VALUE) winklist)))")
  (ACTION_TILE "cancel" "(DONE_DIALOG 0)")
  (ACTION_TILE "accept" "(done_dialog 1)")
  (SETQ ETSTAT (START_DIALOG))
  (COND
    ((= ETSTAT 0) (UNLOAD_DIALOG DCL_ID))
    ((= ETSTAT 1) (TEST_UBS))
    ((= ETSTAT 2) (UNLOAD_DIALOG DCL_ID) (DDCOLORSTART))
  )
  (SETVAR "cmdecho" A_CMD)
  (SETVAR "clayer" A_LAY)
  (SETVAR "cecolor" A_FAR)
  (PRINC)
)

(DEFUN TAKE-LAYER ()
  (SETQ LAY-WAHL (NTH (ATOI $VALUE) LAY_LIS))
  (SETVAR "clayer" LAY-WAHL)
)

(DEFUN UBS_LAY_EINL (/ LAYNAM EINTRAG)
  (SETQ	LAYNAM	(TBLNEXT "LAYER" T)
	EINTRAG	T
	LAY_LIS	(LIST "0")
  ) ;_ Ende von SETQ
  (WHILE EINTRAG
    (SETQ EINTRAG (TBLNEXT "LAYER"))
    (IF	EINTRAG
      (SETQ LAYNAM  (CDR (ASSOC 2 EINTRAG))
	    LAY_LIS (CONS LAYNAM LAY_LIS)
      ) ;_ Ende von SETQ
    )										; End IF
  )										; End WHILE
)

(DEFUN ALERT-T-INFO ()
  (SETQ	T-INFORMATION
	 "Beim Biegen erfahren die verschiedenen Schichten und Fasern des Querschnittes 
unterschiedliche Lngennderungen. In der Abwicklung gebogener Blechkrper 
sind diese Vernderungen der Lnge entsprechend zu bercksichtigen.

Bei einem Biegevorgang werden die Auen Faser gereckt, die innen Faser dagegen gestaucht.
Die mittlere ( neutrale ) Faser dagegen behlt ihre ursprngliche Lage.

Neutrale Faser gleich t/2.

Bei Biegungen ber 90 ist zu beobachten , dass sich die neutrale Faser mehr
nach der inneren Faser verschiebt. Man rechnet in solchen Fllen mit einem 
Verlauf der neutralen Faser im Abstand von t/3 von der inneren Faser. 
Dementsprechend muss auch bei der Berechnung der gestreckten Lnge fr einen 
bestimmten Radius diese Verschiebung bercksichtigt werden.

Die Erfahrung lehrt also, dass beim Abwickeln von Biegeformen alle Mae auf 
die neutrale Faser zu beziehen sind, die beim Runden auf Rundmaschinen und bei 
Biegungen bis zu einem Winkel von 90 in der Mitte des Querschnittes verluft.

Das heit: wir ziehen von den auen Maen die jeweilige Blechdicke ab und erhalten 
so die neutrale Faser.

Im Programm werden die absoluten Mae eingegeben. Bei der Draufsicht und der Ansicht
werden diese Werte bernommen.

Bei der Blechabwicklung hingegen, wird die neutrale Faser bercksichtigt.


mfg



Wilfried Nelkel
CAD-Technik Nelkel
WEB:   http://www.cad-nelkel.de
EMAIL: info@cad-nelkel.de"
  )
  (ALERT T-INFORMATION)
)


(DEFUN DDCOLORSTART (/ NFARBE)
  (IF (OR (= (GETVAR "cecolor") "BYLAYER")
	  (= (GETVAR "cecolor") "VONLAYER")
	  (= (GETVAR "cecolor") "256")
      )
    (SETQ NFARBE (ACAD_COLORDLG 255 1))
    (SETQ NFARBE (ACAD_COLORDLG (ATOI FARBE) 1))
  )
  (IF (= NFARBE 256)
    (SETVAR "cecolor" "256")
    (SETVAR "cecolor" (ITOA NFARBE))
  )
  (SETQ FARBE (ITOA NFARBE))
  (C:UBS)
)


(DEFUN PRFE_FARBE ()
  (SETQ FARBE (ATOI $VALUE))
  (IF (OR (< FARBE 0) (> FARBE 256))
    (PRINC "\nFarbwert nicht zulssig")
    (PROGN (SETQ FARBE (ITOA FARBE)) (SETVAR "cecolor" FARBE) (FARBZEIG))
  )
)

(DEFUN DIA_ZEIG_A (/ V1 V2 SLD_ARC)
  (MODE_TILE "X" 0)
  (MODE_TILE "Y" 0)
  (SETQ	V1 (DIMX_TILE "ubs")
	V2 (DIMY_TILE "ubs")
  ) ;_ Ende von SETQ
  (START_IMAGE "ubs")
  (FILL_IMAGE 0 0 V1 V2 -15)
  (SLIDE_IMAGE 0 0 V1 V2 "uba")
  (END_IMAGE)
  (SETQ	V1 (DIMX_TILE "ctn")
	V2 (DIMY_TILE "ctn")
  ) ;_ Ende von SETQ
  (START_IMAGE "ctn")
  (FILL_IMAGE 0 0 V1 V2 -15)
  (SLIDE_IMAGE 0 0 V1 V2 "ctn")
  (END_IMAGE)
)
(DEFUN DIA_ZEIG	(/ V1 V2)
  (MODE_TILE "X" 1)
  (MODE_TILE "Y" 1)
  (SETQ	V1 (DIMX_TILE "ubs")
	V2 (DIMY_TILE "ubs")
  ) ;_ Ende von SETQ
  (START_IMAGE "ubs")
  (FILL_IMAGE 0 0 V1 V2 -15)
  (SLIDE_IMAGE 0 0 V1 V2 "ubs")
  (END_IMAGE)
  (SETQ	V1 (DIMX_TILE "ctn")
	V2 (DIMY_TILE "ctn")
  ) ;_ Ende von SETQ
  (START_IMAGE "ctn")
  (FILL_IMAGE 0 0 V1 V2 -15)
  (SLIDE_IMAGE 0 0 V1 V2 "ctn")
  (END_IMAGE)
)

(DEFUN FARBZEIG	(/ V1 V2)
  (SETQ	V1 (DIMX_TILE "color")
	V2 (DIMY_TILE "color")
  ) ;_ Ende von SETQ
  (START_IMAGE "color")
  (FILL_IMAGE 0 0 V1 V2 (ATOI (GETVAR "cecolor")))
  (END_IMAGE)
)

(DEFUN TEST_UBS	()
  (IF (OR
	(NULL A)
	(NULL B)
	(NULL D)
	(NULL H)
	(= A 0.0)
	(= B 0.0)
	(= D 0.0)
	(= H 0.0)
      )
    (PROGN
      (ALERT "\nFehlende Wertangabe in einem Feld !")
      (C:UBS)
    )
    (UBS_Z)
  )
)

(DEFUN UBS_Z (/ EINFZ1)

  (SETQ	A_TEMP A
	B_TEMP B
	D_TEMP D
	D      (- D ST)
	A      (- A ST)
	B      (- B ST)
	UMFANG (* D PI)
	SEGLN (/ UMFANG G)
	SEGWIN (/ 360.0 G)
	EINF   (GETPOINT "\nEinfgepunkt whlen :")
	C      (SQRT (+ (* A A) (* B B)))
	RPKT4  (POLAR EINF 0 B)
	RPKT2  (POLAR RPKT4 (BM 90) A)
	RPKT3  (POLAR RPKT2 (BM 180) B)
	RPKT1  EINF
  )

  (IF (= SYMETRISCH 1)
    (PROGN
      (SETQ
	RM1   (POLAR RPKT2 (BM 180) (/ B 2))
	RM2   (POLAR RPKT1 (BM 90) (/ A 2))
	RM3   (POLAR RPKT4 (BM 180) (/ B 2))
	RM4   (POLAR RPKT4 (BM 90) (/ A 2))
	EINF1 (INTERS RPKT1 RPKT2 RPKT3 RPKT4 NIL)
	EINF2 (POLAR EINF1 (BM 90) (* B 1.2))
	KPK1  (POLAR EINF1 (BM 90) (/ D 2))
	KPK2  (POLAR EINF1 (BM 180) (/ D 2))
	KPK3  (POLAR EINF1 (BM 270) (/ D 2))
	KPK4  (POLAR EINF1 (BM 0) (/ D 2))
	LM1   (DISTANCE RM1 KPK1)
	LM2   (DISTANCE RM2 KPK2)
	LM3   (DISTANCE RM3 KPK3)
	LM4   (DISTANCE RM4 KPK4)
	P2_1  (POLAR EINF2 (BM 180) (/ B 2))
	P2_2  (POLAR EINF2 0 (/ B 2))
	P2_5  (POLAR EINF2 (BM 90) H)
	P2_3  (POLAR P2_5 (BM 180) (/ D 2))
	P2_4  (POLAR P2_5 0 (/ D 2))
      )
    )
    (PROGN
      (SETQ
	EINF1  (INTERS RPKT1 RPKT2 RPKT3 RPKT4 NIL)
;;; dieser Punkt ist eigentlich das Zentrum des Rechtecks, wird jedoch spter wieder verschoben, da hier das asymetrische bergangsstck berechnet wird.
	EINFZ1 (POLAR EINF1 0 X)
	EINF1  (POLAR EINFZ1 (BM 90) Y)
	KPK1   (POLAR EINF1 (BM 90) (/ D 2))
	KPK2   (POLAR EINF1 (BM 180) (/ D 2))
	KPK3   (POLAR EINF1 (BM 270) (/ D 2))
	KPK4   (POLAR EINF1 (BM 0) (/ D 2))
	RM1    (INTERS RPKT2 RPKT3 EINF1 KPK1 NIL)
	RM2    (INTERS RPKT3 RPKT1 EINF1 KPK2 NIL)
	RM3    (INTERS RPKT1 RPKT4 EINF1 KPK3 NIL)
	RM4    (INTERS RPKT4 RPKT2 EINF1 KPK4 NIL)
	LM1    (DISTANCE RM1 KPK1)
	LM2    (DISTANCE RM2 KPK2)
	LM3    (DISTANCE RM3 KPK3)
	LM4    (DISTANCE RM4 KPK4)
	P2_1   (POLAR RPKT3 (BM 90) (* A 1.2))
	P2_2   (POLAR P2_1 0 B)
	EINF2  (POLAR P2_1 0 (+ (/ B 2) X))
	P2_5   (POLAR EINF2 (BM 90) H)
	P2_3   (POLAR P2_5 (BM 180) (/ D 2))
	P2_4   (POLAR P2_5 0 (/ D 2))
      )
    )
  )
  (SETQ ALTOS (GETVAR "osmode"))
  (SETVAR "osmode" 0)
  (COMMAND "_circle" EINF1 (/ D 2))
  (COMMAND "_pline" RPKT1 RPKT4 RPKT2 RPKT3 "_c")
  (COMMAND "_line" P2_1 P2_3 P2_4 P2_2 P2_5 P2_1 P2_2 "")

  (ZEICHNE_DRAUFSICHT_TEILUNG)
  (LNGEN_DER_SEGMENTE_BERECHNEN)



;;;****************************************************************************************
;;;****************************************************************************************
;;;****************************************************************************************
;;;****************************************************************************************
;;;****************************************************************************************
;;; Nun wird die Blechabwicklung insgesamt gezeichnet.
;;; Der Punkt P3_1 ist der Startpunkt, welcher vorher berechnet wird.
  (merk_die_punkte)
  (ZEICHNE_SEGMENT4)
  (ZEICHNE_SEGMENT1)
  (ZEICHNE_SEGMENT2)
  (ZEICHNE_SEGMENT3)



  (SETQ UMFANG_OBJ_LI (SSADD (ENTLAST) UMFANG_OBJ_LI))

;;; Nun werden die Linienenden verbunden, damit die Rundung komplett
;;; dargestellt wird.
  (COMMAND "_pline")

  (FOREACH ELE PLINE_LI
    (COMMAND ELE)
  )
  (COMMAND "" "_pedit" "_l" "A" "")
  (SETQ UMFANG_OBJ_LI (SSADD (ENTLAST) UMFANG_OBJ_LI))
  (COMMAND "_pedit" "_last" "v" UMFANG_OBJ_LI "" "")
  (COMMAND "_area" "_o" "_last")
  (SETQ	FLCHE (GETVAR "area")
	UMFANG (GETVAR "perimeter")
  )
  (ZEICHNE_TEXT)
  (ZEICHNE_TABELLE)
  (VERSCHIEBE_TABELLE)
  (SETVAR "osmode" ALTOS)
  (PRINC)
)

(defun merk_die_punkte ()
  (setq	D	  (- D ST)
	A	  (- A ST)
	B	  (- B ST)
	LANG3	  SEGLN
	PLINE_LI  '()
	PUNKT_LI1 (REVERSE PUNKT_LI1)
	PUNKT_LI2 (REVERSE PUNKT_LI2)
	PUNKT_LI3 (REVERSE PUNKT_LI3)
	PUNKT_LI4 (REVERSE PUNKT_LI4)
  )
)


(DEFUN ZEICHNE_DRAUFSICHT_TEILUNG ()
  (SETQ	INDEX 0
	SS1   NIL
	SS1   (SSADD)
	SS2   NIL
	SS2   (SSADD)
	SS3   NIL
	SS3   (SSADD)
	SS4   NIL
	SS4   (SSADD)
  )
;;;*****************************  ss1
  (REPEAT (/ G 4)
    (COMMAND "_line" (POLAR EINF1 (BM (* SEGWIN INDEX)) (/ D 2)) RPKT2 "")
    (SETQ SS1	(SSADD (ENTLAST) SS1)
	  INDEX	(1+ INDEX)
    )
  )
  (COMMAND "_line" (POLAR EINF1 (BM 90) (/ D 2)) RPKT2 "")
  (SETQ	SS1 (SSADD (ENTLAST) SS1)
  )

;;;*****************************  ss2
  (REPEAT (/ G 4)
    (COMMAND "_line" (POLAR EINF1 (BM (* SEGWIN INDEX)) (/ D 2)) RPKT3 "")
    (SETQ SS2	(SSADD (ENTLAST) SS2)
	  INDEX	(1+ INDEX)
    )
  )
  (COMMAND "_line" (POLAR EINF1 (BM 180) (/ D 2)) RPKT3 "")
  (SETQ	SS2 (SSADD (ENTLAST) SS2)
  )

;;;*****************************  ss3
  (REPEAT (/ G 4)
    (COMMAND "_line" (POLAR EINF1 (BM (* SEGWIN INDEX)) (/ D 2)) RPKT1 "")
    (SETQ SS3	(SSADD (ENTLAST) SS3)
	  INDEX	(1+ INDEX)
    )
  )
  (COMMAND "_line" (POLAR EINF1 (BM 270) (/ D 2)) RPKT1 "")
  (SETQ	SS3 (SSADD (ENTLAST) SS3)
  )

;;;*****************************  ss4
  (REPEAT (/ G 4)
    (COMMAND "_line" (POLAR EINF1 (BM (* SEGWIN INDEX)) (/ D 2)) RPKT4 "")
    (SETQ SS4	(SSADD (ENTLAST) SS4)
	  INDEX	(1+ INDEX)
    )
  )
  (COMMAND "_line" (POLAR EINF1 (BM 0) (/ D 2)) RPKT4 "")
  (SETQ	SS4 (SSADD (ENTLAST) SS4)
  )
)

(DEFUN ZEICHNE_SEGMENT3	()
  (SETQ	LZ1   (POLAR P3_1 0 (DISTANCE RPKT3 RM2))
;;;;; hier wichtig HD 2 = links
	P3_3  (POLAR LZ1 (BM 90) HD2)
	P3_2  (POLAR P3_1 0 A)
	LANG1 (DISTANCE P3_2 P3_3)
	ALPHA (GRAD (ANGLE P3_1 P3_3))
	P3_2  (POLAR STP (BM (- WINKELLINKS ALPHA WINKUNTEN)) A)
	P3_3  ENP
	P3_1  STP
	INDEX 0
  )
;;; Zeichnen des Dreiecks                       Segment 3 (oben links) und Breite = a
  (ZEICHNE_DREIECK)
;;;
;;;
  (REPEAT (- (SSLENGTH SS3) 1)
    (LETZTES_OBJEKT_MERKEN)
    (SETQ LANG1	      (NTH INDEX PUNKT_LI3)
	  LANG2	      (NTH (+ INDEX 1) PUNKT_LI3)
	  WINKUNTEN1O (- (+ (* LANG2 LANG2) (* LANG1 LANG1)) (* LANG3 LANG3))
	  WINKUNTEN1U (* 2.0 LANG2 LANG1)
	  WINKUNTEN1  (/ WINKUNTEN1O WINKUNTEN1U)
	  WINKUNTEN   (GRAD (ARCCOS WINKUNTEN1))
	  WINKELLINKS (GRAD (ANGLE STP ENP))
	  INDEX	      (1+ INDEX)
	  P_TEMP      (POLAR P3_2 (BM (- WINKELLINKS WINKUNTEN)) LANG2)
    )
    (DENK_AN_TEXT)
    (COMMAND "_line" P3_2 P_TEMP "")
    (LETZTEN_PUNKT_MERKEN)
  )
  (LETZTES_OBJEKT_MERKEN)
)


(DEFUN ZEICHNE_SEGMENT2	()

  (SETQ	LZ1   (POLAR P3_1 0 (DISTANCE RPKT2 RM1))
;;;;; hier wichtig HD 1 = oben
	P3_3  (POLAR LZ1 (BM 90) HD1)
	P3_2  (POLAR P3_1 0 B)
	LANG1 (DISTANCE P3_2 P3_3)
	ALPHA (GRAD (ANGLE P3_1 P3_3))
	P3_2  (POLAR STP (BM (- WINKELLINKS ALPHA WINKUNTEN)) B)
	P3_3  ENP
	P3_1  STP
	INDEX 0
  )
;;; Zeichnen des Dreiecks                       Segment 2 (oben links) und Breite = B
  (ZEICHNE_DREIECK)
;;;
;;;
  (REPEAT (- (SSLENGTH SS2) 1)
    (LETZTES_OBJEKT_MERKEN)
    (SETQ LANG1	      (NTH INDEX PUNKT_LI2)
	  LANG2	      (NTH (+ INDEX 1) PUNKT_LI2)
	  WINKUNTEN1O (- (+ (* LANG2 LANG2) (* LANG1 LANG1)) (* LANG3 LANG3))
	  WINKUNTEN1U (* 2.0 LANG2 LANG1)
	  WINKUNTEN1  (/ WINKUNTEN1O WINKUNTEN1U)
	  WINKUNTEN   (GRAD (ARCCOS WINKUNTEN1))
	  WINKELLINKS (GRAD (ANGLE STP ENP))
	  INDEX	      (1+ INDEX)
	  P_TEMP      (POLAR P3_2 (BM (- WINKELLINKS WINKUNTEN)) LANG2)
    )
    (DENK_AN_TEXT)
    (COMMAND "_line" P3_2 P_TEMP "")
    (LETZTEN_PUNKT_MERKEN)
  )
  (LETZTES_OBJEKT_MERKEN)
)
(DEFUN ZEICHNE_SEGMENT1	()
  (SETQ	LZ1   (POLAR P3_1 0 (DISTANCE RPKT4 RM4))
;;;;; hier wichtig HD 4 = rechts
	P3_3  (POLAR LZ1 (BM 90) HD4)
	P3_2  (POLAR P3_1 0 A)
	LANG1 (DISTANCE P3_2 P3_3)
	ALPHA (GRAD (ANGLE P3_1 P3_3))
	P3_2  (POLAR STP (BM (- WINKELLINKS ALPHA WINKUNTEN)) A)
	P3_3  ENP
	P3_1  STP
	INDEX 0
  )
;;; Zeichnen des Dreiecks                       Segment 1 (oben rechts) und Breite = a
  (ZEICHNE_DREIECK)
;;;
;;;
  (REPEAT (- (SSLENGTH SS1) 1)
    (LETZTES_OBJEKT_MERKEN)
    (SETQ LANG1	      (NTH INDEX PUNKT_LI1)
	  LANG2	      (NTH (+ INDEX 1) PUNKT_LI1)
	  WINKUNTEN1O (- (+ (* LANG2 LANG2) (* LANG1 LANG1)) (* LANG3 LANG3))
	  WINKUNTEN1U (* 2.0 LANG2 LANG1)
	  WINKUNTEN1  (/ WINKUNTEN1O WINKUNTEN1U)
	  WINKUNTEN   (GRAD (ARCCOS WINKUNTEN1))
	  WINKELLINKS (GRAD (ANGLE STP ENP))
	  INDEX	      (1+ INDEX)
	  P_TEMP      (POLAR P3_2 (BM (- WINKELLINKS WINKUNTEN)) LANG2)
    )
    (DENK_AN_TEXT)
    (COMMAND "_line" P3_2 P_TEMP "")
    (LETZTEN_PUNKT_MERKEN)
  )
  (LETZTES_OBJEKT_MERKEN)
)

(DEFUN ZEICHNE_SEGMENT4	()
  (SETQ	P3_1		(POLAR RPKT4 0 A)
	P3_2		(POLAR P3_1 0 B)
	LZ1		(POLAR P3_1 0 (DISTANCE RPKT1 RM3))
;;;;; hier wichtig HD 3 = unten
	P3_3		(POLAR LZ1 (BM 90) HD3)
	LANG1		(DISTANCE P3_2 P3_3)
	ALPHA		(GRAD (ANGLE P3_1 P3_3))
	INDEX		0
	UMFANG_OBJ_LI	NIL
	UMFANG_OBJ_LI	(SSADD)
	TEXT_INDEX	1
	TEXT_EINTRAG_LI	'()
	TEXT_WIN_LI	'()
	TEXT_START_LI	'()

  )
;;; Zeichnen des Dreiecks                       Segment 4 (unten rechts) und Breite = b
  (COMMAND "_line" P3_3 P3_1 "")
  (SETQ UMFANG_OBJ_LI (SSADD (ENTLAST) UMFANG_OBJ_LI))
  (COMMAND "_line" P3_1 P3_2 "")
  (SETQ UMFANG_OBJ_LI (SSADD (ENTLAST) UMFANG_OBJ_LI))
  (COMMAND "_line" P3_2 P3_3 "")
  (LETZTEN_PUNKT_MERKEN)
  (SETQ	TEXT_EINTRAG	(STRCAT "L" (ITOA TEXT_INDEX))
	TEXT_WIN	(ANGLE P3_2 P3_3)
	TEXT_START	(POLAR P3_2 TEXT_WIN (/ (DISTANCE P3_2 P3_3) 2))
	TEXT_EINTRAG_LI	(CONS TEXT_EINTRAG TEXT_EINTRAG_LI)
	TEXT_WIN_LI	(CONS (GRAD TEXT_WIN) TEXT_WIN_LI)
	TEXT_START_LI	(CONS TEXT_START TEXT_START_LI)
  )
;;;
;;;
  (REPEAT (- (SSLENGTH SS4) 1)
    (LETZTES_OBJEKT_MERKEN)
    (SETQ LANG1	      (NTH INDEX PUNKT_LI4)
	  LANG2	      (NTH (+ INDEX 1) PUNKT_LI4)
	  WINKUNTEN1O (- (+ (* LANG2 LANG2) (* LANG1 LANG1))
			 (* LANG3 LANG3)
		      )
	  WINKUNTEN1U (* 2.0 LANG2 LANG1)
	  WINKUNTEN1  (/ WINKUNTEN1O WINKUNTEN1U)
	  WINKUNTEN   (GRAD (ARCCOS WINKUNTEN1))
	  WINKELLINKS (GRAD (ANGLE STP ENP))
	  INDEX	      (1+ INDEX)
	  P_TEMP      (POLAR P3_2 (BM (- WINKELLINKS WINKUNTEN)) LANG2)
    )
    (DENK_AN_TEXT)
    (COMMAND "_line" P3_2 P_TEMP "")
    (LETZTEN_PUNKT_MERKEN)
  )
  (LETZTES_OBJEKT_MERKEN)
)




(DEFUN LNGEN_DER_SEGMENTE_BERECHNEN ()

;;; Hier werden die Lngen der einzelnen Radien ausgehend
;;; von der Draufsicht errechnet.
;;; die Startpunkte werden in der Liste START_LI gespeichert
;;; die Lngen werden in der Liste LANG_LI gespeichert
  (SETQ	INDEX 0
	LANG_LI1 '()
	START_LI1 '()
	LANG_LI2 '()
	START_LI2 '()
	LANG_LI3 '()
	START_LI3 '()
	LANG_LI4 '()
	START_LI4 '()
  )
;;; Hier werden die Lngen und Startpunkte von ss1 berechnet !  
  (REPEAT (SSLENGTH SS1)
    (SETQ OBJEKT      (SSNAME SS1 INDEX)
	  OBJEKT_DATA (ENTGET OBJEKT)
	  START_PKT   (CDR (ASSOC 10 OBJEKT_DATA))
	  END_PKT     (CDR (ASSOC 11 OBJEKT_DATA))
	  LNGE	      (DISTANCE START_PKT END_PKT)
	  INDEX	      (1+ INDEX)
	  LANG_LI1    (CONS LNGE LANG_LI1)
	  START_LI1   (CONS START_PKT START_LI1)
    )
  )
  (SETQ INDEX 0)
;;; Hier werden die Lngen und Startpunkte von ss2 berechnet !  
  (REPEAT (SSLENGTH SS2)
    (SETQ OBJEKT      (SSNAME SS2 INDEX)
	  OBJEKT_DATA (ENTGET OBJEKT)
	  START_PKT   (CDR (ASSOC 10 OBJEKT_DATA))
	  END_PKT     (CDR (ASSOC 11 OBJEKT_DATA))
	  LNGE	      (DISTANCE START_PKT END_PKT)
	  INDEX	      (1+ INDEX)
	  LANG_LI2    (CONS LNGE LANG_LI2)
	  START_LI2   (CONS START_PKT START_LI2)
    )
  )
  (SETQ INDEX 0)
;;; Hier werden die Lngen und Startpunkte von ss3 berechnet !  
  (REPEAT (SSLENGTH SS3)
    (SETQ OBJEKT      (SSNAME SS3 INDEX)
	  OBJEKT_DATA (ENTGET OBJEKT)
	  START_PKT   (CDR (ASSOC 10 OBJEKT_DATA))
	  END_PKT     (CDR (ASSOC 11 OBJEKT_DATA))
	  LNGE	      (DISTANCE START_PKT END_PKT)
	  INDEX	      (1+ INDEX)
	  LANG_LI3    (CONS LNGE LANG_LI3)
	  START_LI3   (CONS START_PKT START_LI3)
    )
  )
  (SETQ INDEX 0)
;;; Hier werden die Lngen und Startpunkte von ss4 berechnet !  
  (REPEAT (SSLENGTH SS4)
    (SETQ OBJEKT      (SSNAME SS4 INDEX)
	  OBJEKT_DATA (ENTGET OBJEKT)
	  START_PKT   (CDR (ASSOC 10 OBJEKT_DATA))
	  END_PKT     (CDR (ASSOC 11 OBJEKT_DATA))
	  LNGE	      (DISTANCE START_PKT END_PKT)
	  INDEX	      (1+ INDEX)
	  LANG_LI4    (CONS LNGE LANG_LI4)
	  START_LI4   (CONS START_PKT START_LI4)
    )
  )
;;; Hier werden die Lngen- und Startpunktlisten 1-4 umgedreht
  (SETQ	LANG_LI1  (REVERSE LANG_LI1)
	START_LI1 (REVERSE START_LI1)
	LANG_LI2  (REVERSE LANG_LI2)
	START_LI2 (REVERSE START_LI2)
	LANG_LI4  (REVERSE LANG_LI4)
	LANG_LI3  (REVERSE LANG_LI3)
	START_LI3 (REVERSE START_LI3)
	START_LI4 (REVERSE START_LI4)
	INDEX	  0
  )
;;; Nun werden die errechneten Radien in die Frontalsicht bertragen
;;; und anschlieend die Lngen errechnet
;;; die Variablen hd1 - hd4 stehen fr die tatschlichen Mittelhhen der Dreiecke.
  (SETQ	PUNKT_LI1 '()
	PUNKT_LI2 '()
	PUNKT_LI3 '()
	PUNKT_LI4 '()
	PYT_A	  (* H H)
	INDEX	  0
	HD1	  (SQRT (+ PYT_A (* LM1 LM1)))
	HD2	  (SQRT (+ PYT_A (* LM2 LM2)))
	HD3	  (SQRT (+ PYT_A (* LM3 LM3)))
	HD4	  (SQRT (+ PYT_A (* LM4 LM4)))
  )
  (REPEAT (SSLENGTH SS1)
    (SETQ PYT_B	    (* (NTH INDEX LANG_LI1) (NTH INDEX LANG_LI1))
	  PUNKT_LI1 (CONS (SQRT (+ PYT_A PYT_B)) PUNKT_LI1)
	  INDEX	    (1+ INDEX)
    )
  )
  (SETQ INDEX 0)
  (REPEAT (SSLENGTH SS2)
    (SETQ PYT_B	    (* (NTH INDEX LANG_LI2) (NTH INDEX LANG_LI2))
	  PUNKT_LI2 (CONS (SQRT (+ PYT_A PYT_B)) PUNKT_LI2)
	  INDEX	    (1+ INDEX)
    )
  )
  (SETQ INDEX 0)
  (REPEAT (SSLENGTH SS3)
    (SETQ PYT_B	    (* (NTH INDEX LANG_LI3) (NTH INDEX LANG_LI3))
	  PUNKT_LI3 (CONS (SQRT (+ PYT_A PYT_B)) PUNKT_LI3)
	  INDEX	    (1+ INDEX)
    )
  )
  (SETQ INDEX 0)
  (REPEAT (SSLENGTH SS4)
    (SETQ PYT_B	    (* (NTH INDEX LANG_LI4) (NTH INDEX LANG_LI4))
	  PUNKT_LI4 (CONS (SQRT (+ PYT_A PYT_B)) PUNKT_LI4)
	  INDEX	    (1+ INDEX)
    )
  )
)


(DEFUN ZEICHNE_TABELLE (/	      ANZAHL	    ZEILENABSTAND ENDPUNKTNEU	ENDPUNKTNEUZ  MITTEL_LO
			MITTEL_LU     TSPKT1	    TSPKT2	  TSPKT3	TSPKT4	      TSPKT5
			TEXT_STARTPKT WERT_STARTPKT
		       )
  (SETQ	ANZAHL	      (LENGTH TEXT_WIN_LI)
	TSS	      (SSADD)
	STARTPUNKT    (POLAR RPKT1 (BM 270) A)
	ZEILENABSTAND (+ TEXTHHE 4)
  )
  (REPEAT (+ ANZAHL 6)
    (SETQ STARTPUNKT (POLAR STARTPUNKT (BM 270) ZEILENABSTAND)
	  ENDPUNKT   (POLAR STARTPUNKT 0 (* TEXTHHE 70))
    )
    (COMMAND "_line" STARTPUNKT ENDPUNKT "")
    (SETQ TSS (SSADD (ENTLAST) TSS))
  )
  (SETQ STARTPUNKTNEU (POLAR RPKT1 (BM 270) (+ ZEILENABSTAND A)))
  (COMMAND "_line" STARTPUNKT STARTPUNKTNEU "")
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (SETQ	ENDPUNKTNEUZ (POLAR RPKT1 (BM 270) (+ ZEILENABSTAND A))
	ENDPUNKTNEU  (POLAR ENDPUNKTNEUZ 0 (* TEXTHHE 70))
  )
  (COMMAND "_line" ENDPUNKT ENDPUNKTNEU "")
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (SETQ	MITTEL_LO (POLAR STARTPUNKTNEU 0 (* TEXTHHE 20))
	MITTEL_LU (POLAR STARTPUNKT 0 (* TEXTHHE 20))
  )
  (COMMAND "_line" MITTEL_LO MITTEL_LU "")
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (SETQ	TSPKT1 (POLAR STARTPUNKTNEU 0 TEXTHHE)
	TSPKT2 (POLAR TSPKT1 (BM 270) (+ TEXTHHE 2))
	TSPKT3 (POLAR TSPKT2 0 (* TEXTHHE 20))
	TSPKT4 (POLAR TSPKT2 (BM 270) (+ TEXTHHE 4))
	TSPKT5 (POLAR TSPKT4 0 (* TEXTHHE 20))
  )
  (SETVAR "cecolor" (ITOA (+ (ATOI FARBE) 1)))
  (COMMAND "_text" TSPKT2 TEXTHHE "0" "Blechgre")
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (COMMAND "_text"
	   TSPKT3
	   TEXTHHE
	   "0"
	   (STRCAT "Flche = " (RTOS FLCHE 2 4) "  Umfang = " (RTOS UMFANG 2 4))
  )
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (COMMAND "_text" TSPKT4 TEXTHHE "0" "Blechdicke")
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (COMMAND "_text" TSPKT5 TEXTHHE "0" (RTOS ST 2 3))
  (SETQ TSS (SSADD (ENTLAST) TSS))
  (SETQ	GESAMT_LI (APPEND PUNKT_LI4 PUNKT_LI1 PUNKT_LI2 PUNKT_LI3)
	INDEX	  0
  )
  (SETQ	TSPKT4 (POLAR TSPKT4 (BM 270) (* (+ TEXTHHE 4) 2))
	TSPKT5 (POLAR TSPKT5 (BM 270) (* (+ TEXTHHE 4) 2))
  )
  (REPEAT (LENGTH GESAMT_LI)
    (SETQ TEXT_STARTPKT	(POLAR TSPKT4 (BM 270) (* (+ TEXTHHE 4) INDEX))
	  WERT_STARTPKT	(POLAR TSPKT5 (BM 270) (* (+ TEXTHHE 4) INDEX))
    )
    (COMMAND "_text" TEXT_STARTPKT TEXTHHE "0" (STRCAT "L" (ITOA (+ INDEX 1))))
    (SETQ TSS (SSADD (ENTLAST) TSS))
    (COMMAND "_text" WERT_STARTPKT TEXTHHE "0" (RTOS (NTH INDEX GESAMT_LI) 2 3))
    (SETQ TSS (SSADD (ENTLAST) TSS))
    (SETQ INDEX (1+ INDEX))
  )
)

(DEFUN DENK_AN_TEXT (/)
  (SETQ	TEXT_INDEX	(1+ TEXT_INDEX)
	TEXT_EINTRAG	(STRCAT "L" (ITOA TEXT_INDEX))
	P_TEMP		(POLAR P3_2 (BM (- WINKELLINKS WINKUNTEN)) LANG2)
	TEXT_WIN	(ANGLE P3_2 P_TEMP)
	TEXT_START	(POLAR P3_2 TEXT_WIN (/ (DISTANCE P3_2 P_TEMP) 2))
	VOR_FARBE	(GETVAR "cecolor")
	TEXT_EINTRAG_LI	(CONS TEXT_EINTRAG TEXT_EINTRAG_LI)
	TEXT_WIN_LI	(CONS (GRAD TEXT_WIN) TEXT_WIN_LI)
	TEXT_START_LI	(CONS TEXT_START TEXT_START_LI)

  )
  (SETVAR "cecolor" VOR_FARBE)
)

(DEFUN ZEICHNE_TEXT ()
  (SETQ INDEX 0)
  (SETVAR "cecolor" (ITOA (+ (ATOI FARBE) 1)))
  (REPEAT (LENGTH TEXT_EINTRAG_LI)
    (COMMAND "_text"
	     "p"
	     "mz"
	     (NTH INDEX TEXT_START_LI)
	     (RTOS TEXTHHE 2 3)
	     (NTH INDEX TEXT_WIN_LI)
	     (NTH INDEX TEXT_EINTRAG_LI)
    )
    (SETQ INDEX (1+ INDEX))
  )
  (SETVAR "cecolor" VOR_FARBE)
)


(DEFUN ZEICHNE_DREIECK (/)
  (COMMAND "_line" P3_1 P3_2 "")
  (SETQ UMFANG_OBJ_LI (SSADD (ENTLAST) UMFANG_OBJ_LI))
  (COMMAND "_line" P3_1 P3_3 "")
  (COMMAND "_line" P3_2 P3_3 "")
  (LETZTEN_PUNKT_MERKEN)
  (SETQ	TEXT_INDEX	(1+ TEXT_INDEX)
	TEXT_EINTRAG	(STRCAT "L" (ITOA TEXT_INDEX))
	TEXT_WIN	(ANGLE P3_2 P3_3)
	TEXT_START	(POLAR P3_2 TEXT_WIN (/ (DISTANCE P3_2 P3_3) 2))
	TEXT_EINTRAG_LI	(CONS TEXT_EINTRAG TEXT_EINTRAG_LI)
	TEXT_WIN_LI	(CONS (GRAD TEXT_WIN) TEXT_WIN_LI)
	TEXT_START_LI	(CONS TEXT_START TEXT_START_LI)
  )
)


(DEFUN LETZTEN_PUNKT_MERKEN ()
  (SETQ	OBJL	 (ENTGET (ENTLAST))
	EP	 (CDR (ASSOC 11 OBJL))
	PLINE_LI (CONS EP PLINE_LI)
  )
)

(DEFUN LETZTES_OBJEKT_MERKEN ()
  (SETQ	OBJ (ENTGET (ENTLAST))
	STP (CDR (ASSOC 10 OBJ))
	ENP (CDR (ASSOC 11 OBJ))
  )
)


(DEFUN BM (GRAD / GRAD)
  (* PI (/ GRAD 180.0))
) ;_ Ende von defun
(DEFUN GRAD (BOGENMAS / BOGENMAS)
  (* 180 (/ BOGENMAS PI))
) ;_ Ende von defun

(DEFUN ARCCOS (COSVONX /)
  (COND
    ((= COSVONX 1)
     0
    )
    ((= COSVONX -1)
     PI
    )
    ((AND (< COSVONX 1) (> COSVONX -1))
     (+ (ATAN (/ (* COSVONX -1.0) (SQRT (+ (* (* COSVONX -1.0) COSVONX) 1.0)))) (/ PI 2.0))
    )
  )
)

(DEFUN VERSCHIEBE_TABELLE ()

  (COMMAND "_move" TSS "" STARTPUNKT)
)

(PRINC)
